<?php
/*
	Plugin Name: Bin Opt-In
	Plugin URI: https://berginformatik.ch/plugin/bin-opt-in
	Description: Provides features and functions to create an opt-in or double-opt in with contact form 7 (cf7) and other form plugins.
	Version: 1.0.1
	Author: Berg Informatik
	Author URI: https://berginformatik.ch
	Text Domain: bin-opt-in
	Domain Path: /languages
*/

if(!defined('ABSPATH')) { exit; }

define('BIN_OPT_IN_VERSION', '1.0.1');
define('BIN_OPT_IN_URL', plugins_url('', __FILE__));
define('BIN_OPT_IN_DIR', dirname(__FILE__));
define('BIN_OPT_IN_DEBUG', false);

// ext
require_once BIN_OPT_IN_DIR.'/ext/urlLinker.php';

// load main class
require_once BIN_OPT_IN_DIR.'/bin-opt-in.main.php';

// module
require_once BIN_OPT_IN_DIR.'/module/settings.php';
require_once BIN_OPT_IN_DIR.'/module/customposttype.php';

// On plugin activation
register_activation_hook(__FILE__, 'bin_opt_in_activation');
function bin_opt_in_activation()
{
	BinOptIn::activate();
}

// On plugin deactivation
register_deactivation_hook(__FILE__, 'bin_opt_in_deactivation');
function bin_opt_in_deactivation()
{
	BinOptIn::deactivate();
}

// On plugin remove
register_uninstall_hook(__FILE__, 'bin_opt_in_uninstall');
function bin_opt_in_uninstall()
{
	BinOptIn::uninstall();
}

// Run
add_action('plugins_loaded', 'initBinOptIn');
function initBinOptIn()
{	
	new BinOptIn;
	new BinOptIn_Settings;
	new BinOptIn_Customposttype;
}