<!DOCTYPE html>
<html <?=language_attributes()?>>
    <head>
		<meta charset="<?=bloginfo('charset')?>">
		<meta name="viewport" content="width=device-width, initial-scale=1.0">
		
		<title><?php bloginfo('name'); ?> | <?=__('Thank you for confirming your subscription.', 'bin-opt-in')?></title>

		<?php wp_head(); ?>
    </head>
    <body <?php body_class('bin_opt_in_confirm_page'); ?>>
		<?php
		
			// init message
			$icon = 'false-2061132_640';
			$message = __('Something went wrong.', 'bin-opt-in');
			
			if(class_exists('BinContact'))
			{
				if(isset($_REQUEST['a']))
				{
					$a = base64_decode($_REQUEST['a']);
					parse_str($a, $atts);

					if($atts['action'] === 'opt-in' && filter_var($atts['email'], FILTER_VALIDATE_EMAIL))
					{
						// prevent from sending multiple emails
						$sended = false;

						$contacts = get_posts([
							'posts_per_page' => -1,
							'post_type' => 'contact',
							'post_status' => 'any',
							'orderby' => 'date',
							'order' => 'DESC',
							'meta_key' => 'bin_contact_email',
							'meta_value' => $atts['email'],
							'meta_compare' => '='
						]);

						if(count($contacts) > 0)
						{
							// iteration because email is not unique
							foreach($contacts as $contact)
							{
								$contactMeta = get_post_meta($contact->ID);

								if($atts['unlock'] === 'true')
								{
									update_post_meta($contact->ID, 'bin_opt_in_contact', 'registered');
									update_post_meta($contact->ID, 'bin_contact_email_status', 'confirmed');

									// send message only once (if email is not unique)
									if($sended === false)
									{
										// set sended to true
										$sended = true;
										$message = sprintf(__('You have successfully unlocked the entry with the e-mail address %s.', 'bin-opt-in'), '<span class="bin_opt_in_confirm_page_email">'.$contactMeta['bin_contact_email'][0].'</span>');
										$icon = 'hook-1727484_640';

										if($contactMeta['bin_opt_in_contact_admin_unlock'][0] === '1')
										{
											BinOptIn::sendMessageUnlockMessage($contactMeta['bin_contact_first_name'][0], $contactMeta['bin_contact_email'][0]);

											// wp super cache: clear cache
											if(function_exists('wp_cache_clear_cache')) { wp_cache_clear_cache(); }
										}
									}
								}
								else
								{
									update_post_meta($contact->ID, 'bin_opt_in_contact', 'pending');
									update_post_meta($contact->ID, 'bin_contact_email_status', 'confirmed');

									// send message only once (if email is not unique)
									if($sended === false)
									{
										// set sended to true
										$sended = true;
										$message = sprintf(__('Thank you for confirming your email %s. Your request is awaiting approval from the site owner.', 'bin-opt-in'), '<span class="bin_opt_in_confirm_page_email">'.$contactMeta['bin_contact_email'][0].'</span>');
										$icon = 'hook-1727484_640';

										if($contactMeta['bin_opt_in_contact_unlock_message'][0] === '1')
										{
											BinOptIn::sendMessageAdminUnlock($contactMeta['bin_contact_first_name'][0], $contactMeta['bin_contact_email'][0]);
										}
									}
								}
							}
						}
					}
				}
			}
		?>
		<div class="bin_opt_in_confirm_page_wrapper">
			<div class="bin_opt_in_confirm_page_header">
				<div class="bin_opt_in_confirm_page_center_container">
					<span class="bin_opt_in_confirm_page_title"><?=get_bloginfo('name')?></span>
					<span class="bin_opt_in_confirm_page_subtitle"><?=__('You have successfully confirmed your request.', 'bin-opt-in')?></span>
				</div>
			</div>
			<div class="bin_opt_in_confirm_page_body">
				<div class="bin_opt_in_confirm_page_center_container">
					<img class="bin_opt_in_confirm_page_image" src="<?=BIN_OPT_IN_URL?>/images/<?=$icon?>.png">
					<span class="bin_opt_in_confirm_page_message"><?=$message?></span>
				</div>
			</div>
			<div class="bin_opt_in_confirm_page_footer">
				<div class="bin_opt_in_confirm_page_center_container">
					<span class="bin_opt_in_confirm_page_copyright">&copy; <?=date('Y')?> by <?=get_bloginfo('name')?></span>
					<span class="bin_opt_in_confirm_page"><?=__('Proudly provided by <a href="https://berginformatik.ch" class="bin_opt_in_confirm_page_footer_link">Berg Informatik</a>', 'bin-opt-in')?></span>
				</div>
			</div>
		</div>
		
		<?php wp_footer(); ?>
	</body>
</html>