<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

class BinOptIn_Customposttype
{
	public function __construct()
	{
		// extend custom post type contact if plugin exists
		if(class_exists('BinContact'))
		{
			add_action('add_meta_boxes_contact', [$this, 'add_meta_boxes']);
			add_action('save_post_contact', [$this, 'save_post']);	
		
			// extend columns view
			add_filter('manage_edit-contact_columns',  [$this, 'contact_columns'], 20);
			add_action('manage_contact_posts_custom_column',  [$this, 'contact_custom_column'], 10, 2);
		}
	}
	
	function contact_columns($columns)
	{
		$keys = array_keys($columns);
		$index = array_search('date', $keys);
		$pos = false === $index ? count($columns) : $index;
		
		return array_merge(array_slice($columns, 0, $pos), ['opt-in' => __('Opt-in', 'bin-opt-in')], array_slice($columns, $pos));
	}

	function contact_custom_column($column, $post_id)
	{
		if($column === 'opt-in')
		{
			if(get_post_meta($post_id, 'bin_opt_in_contact', true) === 'unregistered')
			{
				echo '<div class="badge-outer"><div class="badge badge-unregistered">'.__('Unregistered', 'bin-opt-in').'</div></div>';
			}
			else if(get_post_meta($post_id, 'bin_opt_in_contact', true) === 'confirming')
			{
				echo '<div class="badge-outer"><div class="badge badge-confirming">'.__('Confirming', 'bin-opt-in').'</div></div>';
			}
			else if(get_post_meta($post_id, 'bin_opt_in_contact', true) === 'pending')
			{
				echo '<div class="badge-outer"><div class="badge badge-pending">'.__('Pending', 'bin-opt-in').'</div></div>';
			}
			else if(get_post_meta($post_id, 'bin_opt_in_contact', true) === 'registered')
			{
				echo '<div class="badge-outer"><div class="badge badge-confirming">'.__('Registered', 'bin-opt-in').'</div></div>';
			}
		}
	}
	
	function add_meta_boxes($post)
	{
		add_meta_box('bin_opt_in_contact_metabox', __('Opt-in', 'bin-opt-in'), [$this, 'bin_opt_in_contact_metabox_build'], 'contact', 'side');
	}
	
	function bin_opt_in_contact_metabox_build($post)
	{
		// make sure the form request comes from WordPress
		wp_nonce_field(basename( __FILE__ ), 'bin_opt_in_meta_box_nonce');
		
		//echo '<label for="bin_opt_in_contact">'.__('Opt-in', 'bin-opt-in').'</label>';
		echo '<select id="bin_opt_in_contact" class="regular-text" type="text" name="bin_opt_in_contact">';
			echo '<option value="unregistered" '.selected(get_post_meta($post->ID, 'bin_opt_in_contact', true), 'unregistered', false).'>'.__('Unregistered', 'bin-opt-in').'</option>';
			echo '<option value="confirming" '.selected(get_post_meta($post->ID, 'bin_opt_in_contact', true), 'confirming', false).'>'.__('Confirming', 'bin-opt-in').'</option>';
			echo '<option value="pending" '.selected(get_post_meta($post->ID, 'bin_opt_in_contact', true), 'pending', false).'>'.__('Pending', 'bin-opt-in').'</option>';
			echo '<option value="registered" '.selected(get_post_meta($post->ID, 'bin_opt_in_contact', true), 'registered', false).'>'.__('Registered', 'bin-opt-in').'</option>';
		echo '</select>';
		
		if(BIN_OPT_IN_DEBUG === true)
		{
			echo '<div style="background-color:#efefef; padding:1rem;">';
				echo '<p><strong>bin_opt_in_contact_double_opt_in:</strong> '.get_post_meta($post->ID, 'bin_opt_in_contact_double_opt_in', true).'</p>';
				echo '<p><strong>bin_opt_in_contact_double_opt_in:</strong> '.get_post_meta($post->ID, 'bin_opt_in_contact_admin_unlock', true).'</p>';
				echo '<p><strong>bin_opt_in_contact_double_opt_in:</strong> '.get_post_meta($post->ID, 'bin_opt_in_contact_unlock_message', true).'</p>';
			echo '</div>';
		}
		
		echo '<ul>';
			echo '<li><strong>'.__('Unregistered', 'bin-opt-in').':</strong> '.__('No action has been performed. The contact is unconfirmed.', 'bin-opt-in').'</li>';
			echo '<li><strong>'.__('Confirming', 'bin-opt-in').':</strong> '.__('A confirmation email was sent to the contact, but he has not yet clicked on the link.', 'bin-opt-in').'</li>';
			echo '<li><strong>'.__('Pending', 'bin-opt-in').':</strong> '.__('The contact has successfully confirmed his email. It is awaiting, that the website owner also confirms this.', 'bin-opt-in').'</li>';
			echo '<li><strong>'.__('Registered', 'bin-opt-in').':</strong> '.__('The contact has been successfully confirmed by his email.', 'bin-opt-in').'</li>';
		echo '</ul>';
	}
	
	function save_post($post_id)
	{
		// verify meta box nonce
		if(!isset($_POST['bin_opt_in_meta_box_nonce']) || !wp_verify_nonce($_POST['bin_opt_in_meta_box_nonce'], basename( __FILE__ ))) { return; }

		// return if autosave
		if(defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) { return; }

		// Check the user's permissions.
		if(!current_user_can('edit_post', $post_id)) { return; }
		
		// store custom fields values
		if(isset($_POST['bin_opt_in_contact'])) { update_post_meta($post_id, 'bin_opt_in_contact', sanitize_text_field($_POST['bin_opt_in_contact'])); }
	}
}
