<?php

class BinOptIn_Settings
{
	/**
	 * add actions
	 */
	function __construct()
	{		
		add_action('admin_menu', [$this, 'admin_menu']);
		add_action('admin_init', [$this, 'bin_opt_in_section_setting']);
	}
	
	/**
	 * register admin menu
	 */
	function admin_menu()
	{
		add_options_page(__('Opt-In', 'bin-opt-in'), __('Opt-In', 'bin-opt-in'), 'manage_options', 'bin-opt-in', [$this, 'bin_opt_in_option_setting']);
	}
	
	function bin_opt_in_option_setting()
	{
		echo '<div class="wrap">';
			self::settingsHeader();
			echo '<form method="post" action="options.php">';
				settings_fields('bin_opt_in_section_setting');
				
				echo '<h2>'.__('Settings', 'bin-opt-in').'</h2>';
				echo '<div class="bin_opt_in_settings_grid">';
					echo '<div class="bin_opt_in_settings_grid_left">';
						echo '<div class="bin_opt_in_settings_grid_block">';
							echo '<div class="bin_opt_in_settings_grid_block_inner">';
								echo '<h3>'.__('Email receiver', 'bin-opt-in').'</h3>';
								echo '<div class="bin_opt_in_settings_grid_block_inner_setting">';
									echo '<p>'.__('Email receiver', 'bin-opt-in').'</p>';
									echo '<div>';
										echo '<input type="text" name="bin_opt_in_email_receiver_address" class="regular-text" value="'.get_option('bin_opt_in_email_receiver_address').'">';
										echo '<p class="description">'.__('Specify the email which will receive all opt-in messages sent by this plugin. If empty, this plugin will send all opt-in messages by default to the admin mail.', 'bin-opt-in').'</p>';
									echo '</div>';
								echo '</div>';
							echo '</div>';	
						echo '</div>';
						echo '<div class="bin_opt_in_settings_grid_block">';
							echo '<div class="bin_opt_in_settings_grid_block_inner">';
								echo '<h3>'.__('Email options', 'bin-opt-in').'</h3>';
								echo '<div class="bin_opt_in_settings_grid_block_inner_setting">';
									echo '<p>'.__('Sender Name', 'bin-opt-in').'</p>';
									echo '<div>';
										echo '<input type="text" name="bin_opt_in_email_sender_name" class="regular-text" value="'.get_option('bin_opt_in_email_sender_name').'">';
										echo '<p class="description">'.__('Change the sender name for all outgoing messages.', 'bin-opt-in').'</p>';
									echo '</div>';
								echo '</div>';
								echo '<div class="bin_opt_in_settings_grid_block_inner_setting">';
									echo '<p>'.__('Sender E-Mail', 'bin-opt-in').'</p>';
									echo '<div>';
										echo '<input type="text" name="bin_opt_in_email_sender_address" class="regular-text" value="'.get_option('bin_opt_in_email_sender_address').'">';
										echo '<p class="description">'.__('Change the sender e-mail address for all outgoing messages.', 'bin-opt-in').'</p>';
									echo '</div>';
								echo '</div>';
								echo '<div class="bin_opt_in_settings_grid_block_inner_setting">';
									echo '<p>'.__('Logo', 'bin-opt-in').'</p>';
									echo '<div>';
										echo '<div class="bin_opt_in_media_select">';
											echo '<div class="bin_opt_in_media_field">';
												echo '<input type="url" name="bin_opt_in_email_template_logo" id="bin_opt_in_email_template_logo" class="regular-text" value="'.get_option('bin_opt_in_email_template_logo').'">';
												echo '<a href="#" class="bin_opt_in_empty_field"><span class="dashicons dashicons-dismiss"></span></a>';
											echo '</div>';
											echo '<button type="button" class="button" id="bin_opt_in_email_template_logo_btn" data-media-uploader-target="#bin_opt_in_email_template_logo">'.__('Upload Media', 'bin-opt-in').'</button>';
										echo '</div>';
										echo '<p class="description">'.__('Here you can upload your own logo or for your emails.', 'bin-opt-in').'</p>';
									echo '</div>';
								echo '</div>';
								echo '<div class="bin_opt_in_settings_grid_block_inner_setting">';
									echo '<p>'.__('Background color', 'bin-opt-in').'</p>';
									echo '<div>';
										echo '<input type="text" name="bin_opt_in_email_template_background_color" class="bin_opt_in_color_picker" value="'.get_option('bin_opt_in_email_template_background_color').'">';
										echo '<p class="description">'.__('Here you can set the email background color.', 'bin-opt-in').'</p>';
									echo '</div>';
								echo '</div>';
								echo '<div class="bin_opt_in_settings_grid_block_inner_setting">';
									echo '<p>'.__('Footer Text color', 'bin-opt-in').'</p>';
									echo '<div>';
										echo '<input type="text" name="bin_opt_in_email_template_footer_text_color" class="bin_opt_in_color_picker" value="'.get_option('bin_opt_in_email_template_footer_text_color').'">';
										echo '<p class="description">'.__('Here you can set the email footer text color.', 'bin-opt-in').'</p>';
									echo '</div>';
								echo '</div>';
								echo '<div class="bin_opt_in_settings_grid_block_inner_setting">';
									echo '<p>'.__('Content background color', 'bin-opt-in').'</p>';
									echo '<div>';
										echo '<input type="text" name="bin_opt_in_email_template_container_background_color" class="bin_opt_in_color_picker" value="'.get_option('bin_opt_in_email_template_container_background_color').'">';
										echo '<p class="description">'.__('Here you can set the email content background color.', 'bin-opt-in').'</p>';
									echo '</div>';
								echo '</div>';
								echo '<div class="bin_opt_in_settings_grid_block_inner_setting">';
									echo '<p>'.__('Content text color', 'bin-opt-in').'</p>';
									echo '<div>';
										echo '<input type="text" name="bin_opt_in_email_template_container_text_color" class="bin_opt_in_color_picker" value="'.get_option('bin_opt_in_email_template_container_text_color').'">';
										echo '<p class="description">'.__('Here you can set the email content text color.', 'bin-opt-in').'</p>';
									echo '</div>';
								echo '</div>';
								echo '<div class="bin_opt_in_settings_grid_block_inner_setting">';
									echo '<p>'.__('Footer Name', 'bin-opt-in').'</p>';
									echo '<div>';
										echo '<input type="text" name="bin_opt_in_email_template_brand_name" class="regular-text" value="'.get_option('bin_opt_in_email_template_brand_name').'">';
										echo '<p class="description">'.__('Rebrand the email footer in visitor communication by inserting a new brand name here.', 'bin-opt-in').'</p>';
									echo '</div>';
								echo '</div>';
								echo '<div class="bin_opt_in_settings_grid_block_inner_setting">';
									echo '<p>'.__('Footer URL', 'bin-opt-in').'</p>';
									echo '<div>';
										echo '<input type="text" name="bin_opt_in_email_template_brand_url" class="regular-text" value="'.get_option('bin_opt_in_email_template_brand_url').'">';
										echo '<p class="description">'.__('Rebrand the email footer in visitor communication by inserting a new brand url here.', 'bin-opt-in').'</p>';
									echo '</div>';
								echo '</div>';
							echo '</div>';
						echo '</div>';
					echo '</div>';
					echo '<div class="bin_opt_in_settings_grid_right">';
						echo '<div class="bin_opt_in_settings_grid_block">';
							echo '<div class="bin_opt_in_settings_grid_block_inner">';
								echo '<h3>'.__('Dependencies', 'bin-opt-in').'</h3>';
								echo '<div class="bin_opt_in_settings_grid_block_inner_setting">';
									echo '<p>'.__('Dependency check', 'bin-opt-in').'</p>';
									echo '<div>';
										echo '<label class="bin_opt_in_switch">';
											echo '<input type="checkbox" name="bin_opt_in_dependency_check" value="enabled" '.checked('enabled', get_option('bin_opt_in_dependency_check'), false).'>';
											echo '<span class="slider"></span>';
										echo '</label>';
										echo '<p class="description">'.__('If enabled, the system will show error messages in the wp admin of missing plugin dependencies.', 'bin-opt-in').'</p>';
									echo '</div>';
								echo '</div>';
							echo '</div>';
						echo '</div>';
					echo '</div>';
				echo '</div>';

	            submit_button();
			echo '</form>';
		echo '</div>';
	}
	
	/**
	 * Section Campaign
	 */
	function bin_opt_in_section_setting()
	{		
		register_setting('bin_opt_in_section_setting', 'bin_opt_in_email_receiver_address');
		
		register_setting('bin_opt_in_section_setting', 'bin_opt_in_email_sender_name');
		register_setting('bin_opt_in_section_setting', 'bin_opt_in_email_sender_address');
		register_setting('bin_opt_in_section_setting', 'bin_opt_in_email_template_logo');
		register_setting('bin_opt_in_section_setting', 'bin_opt_in_email_template_background_color');
		register_setting('bin_opt_in_section_setting', 'bin_opt_in_email_template_footer_text_color');
		register_setting('bin_opt_in_section_setting', 'bin_opt_in_email_template_container_background_color');
		register_setting('bin_opt_in_section_setting', 'bin_opt_in_email_template_container_text_color');
		register_setting('bin_opt_in_section_setting', 'bin_opt_in_email_template_brand_name');
		register_setting('bin_opt_in_section_setting', 'bin_opt_in_email_template_brand_url');
		
		register_setting('bin_opt_in_section_setting', 'bin_opt_in_dependency_check');
	}

	/**
	 * Header for settings page
	 */
	static function settingsHeader()
	{
		echo '<div class="bin_opt_in_settings_hero">';
			echo '<div class="bin_opt_in_settings_hero_inner">';
				echo '<h1>Bin Opt-In</h1>';
			echo '</div>';
		echo '</div>';
		echo '<div class="bin_opt_in_banner_linklist">';
			echo '<a href="https://wordpress.org/plugins/bin-opt-in/#reviews" target="_blank"><span class="dashicons dashicons-star-filled"></span><span class="dashicons dashicons-star-filled"></span><span class="dashicons dashicons-star-filled"></span><span class="dashicons dashicons-star-filled"></span><span class="dashicons dashicons-star-filled"></span> '.__('Rate this plugin', 'bin-opt-in').'</a>';
			echo '<span>|</span>';
			echo '<a href="https://wordpress.org/plugins/bin-opt-in" target="_blank">'.__('WordPress plugin directory', 'bin-opt-in').'</a>';
			echo '<span>|</span>';
			echo '<a href="https://berginformatik.ch" target="_blank">'.__('Visit Berg Informatik', 'bin-opt-in').'</a>';
			echo '<span>|</span>';
			echo '<a href="https://wordpress.org/support/plugin/bin-opt-in" target="_blank">'.__('Support', 'bin-opt-in').'</a>';
		echo '</div>';
	}
}